/*
 * See the dyninst/COPYRIGHT file for copyright information.
 * 
 * We provide the Paradyn Tools (below described as "Paradyn")
 * on an AS IS basis, and do not warrant its validity or performance.
 * We reserve the right to update, modify, or discontinue this
 * software at any time.  We shall have no obligation to supply such
 * updates or modifications or any other form of support to you.
 * 
 * By your use of Paradyn, you understand and agree that we (or any
 * other person or entity with proprietary rights in Paradyn) are
 * under no obligation to provide either maintenance services,
 * update services, notices of latent defects, or correction of
 * defects for Paradyn.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#ifndef __UTIL_H__
#define __UTIL_H__

#include <string>
#include "dyntypes.h"
#include "dyninst_visibility.h"


namespace Dyninst {

DYNINST_EXPORT unsigned addrHashCommon(const Address &addr);
DYNINST_EXPORT unsigned ptrHash(const void * addr);
DYNINST_EXPORT unsigned ptrHash(void * addr);

DYNINST_EXPORT unsigned addrHash(const Address &addr);
DYNINST_EXPORT unsigned addrHash4(const Address &addr);
DYNINST_EXPORT unsigned addrHash16(const Address &addr);

DYNINST_EXPORT unsigned stringhash(const std::string &s);
DYNINST_EXPORT std::string itos(int);
DYNINST_EXPORT std::string utos(unsigned);

#define WILDCARD_CHAR '?'
#define MULTIPLE_WILDCARD_CHAR '*'

DYNINST_EXPORT bool wildcardEquiv(const std::string &us, const std::string &them, bool checkCase = false );

const char *platform_string();
}

#endif
